//Final Project
//Moonyoung Lee (ml634) and Kevin Wang (kjw36)
//ECE4760 2014

#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <string.h>
#include "lcd_lib.h"
#include <math.h> 
#include <avr/sleep.h>

#include <avr/eeprom.h> 
#include "i2cmaster.h"
#include "MPU6050.h"


#include "uart.h"
// UART file descriptor
// putchar and getchar are in uart.c
FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

#define UART_BAUD_RATE 57600


//timeout counter for tasks        
volatile unsigned int tLED = 1000;   //1000ms to toggle
volatile unsigned int tADC = 10;	//10ms to capture ADC of phototransistor
volatile unsigned int pwmCount = 0; //20mS to capture servo position
volatile unsigned int pwmThreshold1 = 20;  //range from 10-25
volatile unsigned int pwmThreshold2 = 20;  //range from 10-25
volatile unsigned int pwmThreshold3 = 20;  //range from 10-25
volatile unsigned int pwmThreshold4 = 20;  //range from 10-25
// the usual
#define begin {
#define end }

char Ain; //raw A to D
char switchMUX = 0;
uint16_t parameter1 = 0;
uint16_t parameter2 = 0;
uint16_t parameter3 = 0;
uint16_t parameter4 = 0;
uint16_t parameterPot = 0;
uint16_t sizeMM1 = 0;
uint16_t sizeMM2= 0;
uint16_t sizeMM3 = 0;
uint16_t sizeMM4 = 0;
uint16_t LCDcounter = 0;

uint16_t distance = 0;


//IMU variables
long *ptr = 0;
double qw = 1.0f;
double qx = 0.0f;
double qy = 0.0f;
double qz = 0.0f;
double roll = 0.0f;
double pitch = 0.0f;
double yaw = 0.0f;

//LCD buffer
const int8_t LCD_initialize[] PROGMEM = "LCD initialized\0";
const int8_t LCD_lightSize[] PROGMEM = "size: ";
const int8_t LCD_cm[] PROGMEM = " cm";

const uint8_t lcd_buffer[17];



//functions declared
void initialize(void);
void initializeIMU(void);
void blinkHBEAT(void);
void adc_init(void);
void initServo(void);
void lcd_init(void);

//**********************************************************
//timer 2 compare ISR
//enters every 1 mS
ISR (TIMER2_COMPA_vect) 
begin      
  //Decrement the time if not already zero
  if (tLED>0)	--tLED;
  if (tADC>0)	--tADC;


end  

//**********************************************************
//timer 1 compare ISR 
//enters every 0.01 mS
ISR (TIMER1_COMPA_vect) 
begin     

	////incrememt every 0.1 ms upto 20 ms
	pwmCount++; 

 
 	if (pwmCount>200)	 {pwmCount = 0;}
	if ((pwmCount < 17) && (parameter1 < 30)){
		PORTB |= (1<<PINB1);
	}
	else if((pwmCount < pwmThreshold1) && (parameter1 > 30))   PORTB |= (1<<PINB1);	
	else  				PORTB &= ~(1<<PINB1);
	
	if (pwmCount>200)	 {pwmCount = 0;}
	if ((pwmCount < 22) && (parameter2 < 20)){
		PORTB |= (1<<PINB2);
	}
	else if(pwmCount < pwmThreshold2 && (parameter2 > 20))   PORTB |= (1<<PINB2);	
	else  				PORTB &= ~(1<<PINB2);

	if (pwmCount>200)	 {pwmCount = 0;}
	if ((pwmCount < 15) && (parameter3 < 30)){
		PORTB |= (1<<PINB3);
	}
	else if(pwmCount < pwmThreshold3 && (parameter3 > 30))   PORTB |= (1<<PINB3);	
	else  				PORTB &= ~(1<<PINB3);

	if (pwmCount>200)	 {pwmCount = 0;}
	if ((pwmCount < 22) && (parameter4 < 30)){
		PORTB |= (1<<PINB4);
	}
	else if(pwmCount < pwmThreshold4 && (parameter4 > 30))   PORTB |= (1<<PINB4);	
	else  				PORTB &= ~(1<<PINB4);


	


end  
//**********************************************************

int main(void)
begin

	initialize();
	initializeIMU();
	

	while(1) 
	begin
		
		if(tLED <= 0) 
		{	blinkHBEAT(); 
			
		}		

		if(tADC <= 0) {
			adc2LCD0();
			adc2LCD1();
			adc2LCD2();
			adc2LCD3();
			adc2LCD4();
		
		}	
		initServo();

		LCDcounter++;
		if(LCDcounter == 20){

		LCDclr();
		CopyStringtoLCD(LCD_lightSize, 0, 0);
		CopyStringtoLCD(LCD_cm, 9, 0);

		LCDcounter = 0;
		itoa(distance,lcd_buffer,10);
		LCDGotoXY(6,0);
		
		

		LCDstring(lcd_buffer,strlen(lcd_buffer));
		}


	end

end

//********************************************************** 
//blink LED
void blinkHBEAT(void)
begin
	tLED = 1000;
	PORTB ^= (1<<PINB0);
end

//*******************************************************************************************************
//ADC input to LCD display
void adc2LCD0(void)
begin
	//tADC = 100;
	
	

	//get the sample  
	 Ain = ADCH;
	 //start another conversion
	 ADCSRA |= (1<<ADSC); 

	 	ADMUX = (1<<ADLAR) | (1<<REFS0); 
		parameterPot = (Ain); 	
		if (parameterPot >= 25){
			distance =	0.059*parameterPot + 0.7862;
	 	} else {
			distance = 0;
		}
	fprintf(stdout,"param:    %d    ", parameterPot) ;
	fprintf(stdout,"dist:    %d    ", distance) ;

end

//ADC input to LCD display
void adc2LCD1(void)
begin
	//tADC = 100;
	
	

	//get the sample  
	 Ain = ADCH;
	 //start another conversion
	 ADCSRA |= (1<<ADSC); 

		 ADMUX = (1<<ADLAR) | (1<<REFS0) | (1<<MUX0); 
		 parameter1 = (Ain); 
		 sizeMM1 = 2131*pow(Ain,-0.766); //conversion to mm	

		 fprintf(stdout,"%d,   ", parameter1) ;


end

//ADC input to LCD display
void adc2LCD2(void)
begin
//	tADC = 100;
	
	

	//get the sample  
	 Ain = ADCH;
	 //start another conversion
	 ADCSRA |= (1<<ADSC); 

		 ADMUX = (1<<ADLAR) | (1<<REFS0) | (1<<MUX1); 
		 parameter2 = (Ain); 
		 sizeMM2 = 2131*pow(Ain,-0.766); //conversion to mm

	 fprintf(stdout,"%d,    ", parameter2) ;


end

//ADC input to LCD display
void adc2LCD3(void)
begin
	//tADC = 100;
	
	

	//get the sample  
	 Ain = ADCH;
	 //start another conversion
	 ADCSRA |= (1<<ADSC); 

	 //display to LCD 
	 //convert 0-255 (0-5V) scale to size in inches

		 ADMUX = (1<<ADLAR) | (1<<REFS0) | (1<<MUX1) | (1<<MUX0); 
		 parameter3 = (Ain); 
		 sizeMM3 = 2131*pow(Ain,-0.766); //conversion to mm

	 fprintf(stdout,"%d,    ", parameter3) ;


end

//ADC input to LCD display
void adc2LCD4(void)
begin
	//tADC = 100;
	
	

	//get the sample  
	 Ain = ADCH;
	 //start another conversion
	 ADCSRA |= (1<<ADSC); 

		 ADMUX = (1<<ADLAR) | (1<<REFS0) | (1<<MUX2); 
		 parameter4 = (Ain); 
		 sizeMM4 = 2131*pow(Ain,-0.766); //conversion to mm

	 fprintf(stdout,"%d,    \n", parameter4) ;


end


//*************************************************************************************************************** 
//Task output to PuTTY 
void toPUTTY(void) 
begin
	fprintf(stdout,"%d  \n\r", tLED) ;

end

//******************************* 
//servo drive
void initServo(void) 
begin
	
	//take input from phototransistor
	//vary the servo to match mapping

	pwmThreshold1 = 25-5*((log10(sizeMM1))-1.4);
	pwmThreshold2 = 10+15*((log10(sizeMM2))-1.4);
	pwmThreshold3 = 25-5*((log10(sizeMM3))-1.4);
	pwmThreshold4 = 12+13*((log10(sizeMM4))-1.4);
	

	
end



//********************************************************** 
//Set up IMU mpu6050
void initializeIMU(void)
begin

	//init mpu6050
	//mpu6050_init();
	_delay_ms(50);

	
end

//********************************************************** 
//Set up ADC
void adc_init(void)
begin
//init the A to D converter  
   //set prescaler to 1/128*16MHz=125,000
   //and clear interupt enable
   //and start a conversion
   //USE ADC MUX to use 4 ADC input pins
   ADCSRA =  (1<<ADEN) | (1<<ADSC) + 7; 
   

   //channel zero/ left adj /EXTERNAL Aref
   //MUX to utilize
   ADMUX = (1<<ADLAR) | (1<<REFS0); //ADC0  PA0 by default 
end



//********************************************************** 
//Set up LCD
void lcd_init(void)
begin
	LCDinit();
	LCDcursorOFF();
	LCDclr();
	LCDGotoXY(0,0);
	CopyStringtoLCD(LCD_initialize, 0, 0);
	LCDclr();
end
//********************************************************** 
//Set it all up
void initialize(void)
begin

//******set up timer 2 for 1 mSec timebase ******//
  	TIMSK2= (1<<OCIE2A);	//turn on timer 0 cmp match ISR 
  	OCR2A = 250;  		//set the compare re to 250 time ticks        

    //set prescalar to divide by 64 timer 0
  	TCCR2B= 3; //0b00001011;	 

    // turn on clear-on-match
  	TCCR2A= (1<<WGM01) ;


//******set up timer 1 for 0.5uS timerbase for servo******//
	//servo PWM period is 20 ms
	TIMSK1= (1<<OCIE1A);	//turn on timer 1 cmp match ISR 
	OCR1A = 200;			//enter ISR every 0.1 mS

	TCCR1B = (1<<WGM12)|(1<<CS11); 			//prescalar divide by 8 and CTC mode 4
 


//******set directions for pin******//

	DDRB |= (1<<PINB0) ;		//set PINB.0 as output for  LED
	DDRB |= (1<<PINB1);			//set PINB.1 as output for  servo1
	DDRB |= (1<<PINB2);			//set PINB.2 as output for  servo2
	DDRB |= (1<<PINB3);			//set PINB.3 as output for  servo3
	DDRB |= (1<<PINB4);			//set PINB.4 as output for  servo4



	//init the UART -- uart_init() is in uart.c
	uart_init();
	//init the ADC
	adc_init();
    //init the LCD
	lcd_init();
	
	stdout = stdin = stderr = &uart_str;
	fprintf(stdout,"Starting Final Project...\n\r");
	

	//crank up the ISRs
  	sei();
end
